#include <gnome.h>
#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

// main.cpp
gint right_click_handler(GtkWidget *widget, GdkEventButton *event, gpointer *data);
void show_selected_item(GtkWidget *root_tree, GtkWidget *selected_item, gpointer *data);
void unshow_selected_item(GtkWidget *root_tree, GtkWidget *selected_item, gpointer *data);
void copy_chars(char *source, char *dest, int max_chars);
void flush_file(gchar *name);
void directory_stuff();
void save_prefs();
void adjust_sensitivity();
void destroy(GtkWidget *widget, gpointer data);
void kill_widget(GtkWidget *widget, GtkWidget *killer);

char gCat_dir[256] = "";
char tempfile1[256] = "";
char tempfile2[256] = "";

#define ITEMS    3
#define PRICE    0
#define QUANTITY 1
#define IMAGE    2
char *items[ITEMS] = { "price = [", "quantity = [", "image = [" };
char item_values[ITEMS][256] = { "", "", "" };

struct opened_file
{
   GtkWidget *text;
   GtkWidget *scroller;
   gchar filename[256];
}cur_file;

GtkWidget *window;
GtkWidget *whole_window_box;
GtkWidget *image_box;
GtkWidget *main_box;
GtkWidget *table;
GtkWidget *tree_window;
GtkWidget *tree_widget;
GtkWidget *props_box;
GtkWidget *props_price_label;
GtkWidget *props_price_entry;
GtkWidget *props_qty_label;
GtkWidget *props_qty_entry;
GtkWidget *props_image_label;
GtkWidget *props_image_entry;
GtkWidget *file_selector;
GdkColor black;
GdkColor red;
GdkColor blue;
GdkColor green;
GtkWidget *cur_selected_item;
GtkWidget *cur_selected_tree;
  
GtkWidget *pixmapwid;
GdkPixmap *pixmap;
GdkBitmap *mask;
GtkStyle *style;
gchar *noimage_filename = "/usr/local/share/pixmaps/noimage.png";
gchar *aboutimage_filename = "/usr/local/share/pixmaps/gCatalog-about.png";

// files.cpp
void new_file(struct GtkWidget *, gpointer *data);
void file_ok_sel(GtkWidget *widget, GtkFileSelection *fs);
void open_file(GtkWidget *widget, gpointer *data);
void close_file(GtkWidget *widget, gpointer *data);
void save_file(GtkWidget *widget, gpointer *data);
void save_file_as(GtkWidget *widget, gpointer *data);
void save_as(GtkWidget *widget, GtkFileSelection *fs);
void copy_file(gchar *source, gchar *dest);


// edit.cpp
void change_text(GtkWidget *widget, gpointer *data);
void save_text(GtkWidget *widget, GtkWidget *text);
void insert_new_cat(GtkWidget *widget, gpointer *data);
void insert_cat(GtkWidget *widget, gpointer *data);
void insert_new_subcat(GtkWidget *widget, gpointer *data);
void insert_subcat(GtkWidget *widget, gpointer *data);
void insert_new_item(GtkWidget *widget, gpointer *data);
void insert_item(GtkWidget *widget, gpointer *data);
void item_to_category(GtkWidget *widget, gpointer *data);
void category_to_item(GtkWidget *widget, gpointer *data);
void delete_item(GtkWidget *widget, gpointer *data);

GtkWidget *change_dialog_window;
GtkWidget *main_dialog_box;
GtkWidget *text_dialog_box;
GtkWidget *edited_text;
GtkWidget *edited_scroller;
GtkWidget *entry_dialog_box;
GtkWidget *dialog_label;
GtkWidget *dialog_entry;
GtkWidget *dialog_label2;
GtkWidget *dialog_entry2;
GtkWidget *pixmap_entry;
GtkWidget *buttons_box;
GtkWidget *ok_button;
GtkWidget *cancel_button;


// options.cpp
void change_settings(GtkWidget *widget, gpointer *data);
void save_settings(GtkWidget *widget, gpointer *data);
void get_defaults(GtkWidget *widget, gpointer *data);
void get_backups(GtkWidget *widget, gpointer *data);
GtkWidget *make_button(gchar *button_text, gint *value, GtkWidget *which_box);
void toggle_value(GtkWidget *w, gint *value);
void write_file_to_gtktext(gchar *filename, GtkWidget *text, GdkColor *color);
GtkWidget *allow_delete;
GtkWidget *allow_edit;
GtkWidget *allow_images;
GtkWidget *save_button;
GtkWidget *defaults_button;
GtkWidget *undo_button;

#define PREFS 3
#define ALLOW_DELETE 0
#define ALLOW_EDIT 1
#define SHOW_IMAGES 2
char *prefs[PREFS] = { "ALLOW_DELETE", "ALLOW_EDIT", "SHOW_IMAGES" };
int default_prefs[PREFS] = { 1, 1, 1 };
int backup_prefs[PREFS] = { 0, 0, 0};
int cur_prefs[PREFS] = { 0, 0, 0 };

// maketree.cpp
void make_tree(GtkWidget *tree, const char *FileName);

// getprefs.cpp
void get_prefs();
void save_prefs(gboolean which);

// menus.cpp
void make_menus();
void read_help(GtkWidget *widget);
void read_license(GtkWidget *widget);

// toolbar.cpp
void make_toolbar();


#include "maketree.cpp"   
#include "files.cpp"
#include "edit.cpp"
#include "options.cpp"
#include "getprefs.cpp"
#include "menus.cpp"
#include "toolbar.cpp"
