
void new_file(GtkWidget *widget, gpointer *data)
{
   gtk_editable_delete_text(GTK_EDITABLE(cur_file.text), 0, -1);
   gtk_tree_clear_items(GTK_TREE(tree_widget), 0, -1);
   strcpy(cur_file.filename, "Untitled");
   flush_file(tempfile1);
   flush_file(tempfile2);
   cur_selected_item = NULL;
   cur_selected_tree = NULL;
   kill_widget(pixmapwid, pixmapwid);
   pixmapwid = gnome_pixmap_new_from_file(aboutimage_filename);
   gtk_box_pack_start(GTK_BOX(image_box), pixmapwid, FALSE, FALSE, 5);
   gtk_widget_show(pixmapwid);
   adjust_sensitivity();
}

void open_file(GtkWidget *widget, gpointer *data)
{
   file_selector = gtk_file_selection_new ("Open File");
   gtk_file_selection_set_filename(GTK_FILE_SELECTION(file_selector),"~/.gCatalog/");
   gtk_signal_connect(GTK_OBJECT(file_selector), "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT (file_selector));
   gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION (file_selector)->ok_button), "clicked", GTK_SIGNAL_FUNC(file_ok_sel),  file_selector);
   gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->ok_button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(file_selector));
   gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->cancel_button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(file_selector));
   gtk_widget_show(file_selector);
}

void file_ok_sel(GtkWidget *widget, GtkFileSelection *fs)
{
   gchar *string;   
   string = gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs));
   strcpy(cur_file.filename, string);
   gtk_tree_clear_items(GTK_TREE(tree_widget), 0, -1);
   make_tree(GTK_WIDGET(tree_widget), string);
   cur_selected_item = NULL;
   cur_selected_tree = NULL;
   copy_file(cur_file.filename, tempfile1);
   flush_file(tempfile2);
   gtk_editable_delete_text(GTK_EDITABLE(cur_file.text), 0, -1);
   kill_widget(pixmapwid, pixmapwid);
   pixmapwid = gnome_pixmap_new_from_file(aboutimage_filename);
   gtk_box_pack_start(GTK_BOX(image_box), pixmapwid, FALSE, FALSE, 5);
   gtk_widget_show(pixmapwid);
   adjust_sensitivity();
}

void close_file(GtkWidget *widget, gpointer *data)
{
   gtk_editable_delete_text(GTK_EDITABLE(cur_file.text), 0, -1);
   gtk_tree_clear_items(GTK_TREE(tree_widget), 0, -1);   
   strcpy(cur_file.filename, "Untitled");
   flush_file(tempfile1);
   flush_file(tempfile2);   
   cur_selected_item = NULL;
   cur_selected_tree = NULL;
   kill_widget(pixmapwid, pixmapwid);
   pixmapwid = gnome_pixmap_new_from_file(aboutimage_filename);
   gtk_box_pack_start(GTK_BOX(image_box), pixmapwid, FALSE, FALSE, 5);
   gtk_widget_show(pixmapwid);
   adjust_sensitivity();
}

void save_file(GtkWidget *widget, gpointer *data)
{
   if((strcmp(cur_file.filename, "Untitled")) == 0)
   {
      save_file_as(widget, data);
      return;
   }
   else
   {
      copy_file(tempfile1, cur_file.filename);
      flush_file(tempfile2);
      return;
   }
}

void save_file_as(GtkWidget *widget, gpointer *data)
{
   file_selector = gtk_file_selection_new("Save File As");
   gtk_signal_connect(GTK_OBJECT (file_selector), "destroy", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT (file_selector));
   gtk_signal_connect(GTK_OBJECT (GTK_FILE_SELECTION (file_selector)->ok_button), "clicked", GTK_SIGNAL_FUNC(save_as),  file_selector);
   gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->ok_button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT (file_selector));
   gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(file_selector)->cancel_button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT (file_selector));
   gtk_widget_show(file_selector);
}

void save_as(GtkWidget *widget, GtkFileSelection *fs)
{
   gchar *string;
   string = gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs));
   copy_file(tempfile1, string);
   flush_file(tempfile2);
   strcpy(cur_file.filename, string);
}

void copy_file(gchar *source, gchar *dest)
{
   char input[257];
   ifstream Input;
   Input.open(source);
   ofstream Output;
   Output.open(dest);
   while(Input.getline(input, 256) != NULL)
   {
      Output << input << endl;
   }   
   Input.close();
   Output.close();
}      
