#include "declarations.h"

int main(int argc, char *argv[])
{
   g_snprintf(gCat_dir, sizeof(gCat_dir), "%s/.gCatalog", getenv("HOME"));
   g_snprintf(tempfile1, sizeof(tempfile1), "%s/temp1.itm", gCat_dir);
   g_snprintf(tempfile2, sizeof(tempfile2), "%s/temp2.itm", gCat_dir);   
   directory_stuff();

   black.red = 0;
   black.green = 0;
   black.blue = 0;
   red.red = 65535;
   red.green = 0;
   red.blue = 0;
   green.red = 0;
   green.green = 65535;
   green.blue = 0;
   blue.red = 0;
   blue.green = 0;
   blue.blue = 65535;
   
   gnome_init("gCatalog", "0.1.1", argc, argv);

/* initialize the window and give it a name and a size */

   window = gnome_app_new("gCatalog", "gCatalog v0.1.1 - by Chicane");
   gtk_container_set_border_width(GTK_CONTAINER(window), 10);

/* this stuff is apparently for the window manager */
   gtk_signal_connect(GTK_OBJECT(window), "delete_event", GTK_SIGNAL_FUNC (destroy), NULL);
   gtk_signal_connect(GTK_OBJECT(window), "destroy", GTK_SIGNAL_FUNC (destroy), NULL);
   
   make_menus();
   make_toolbar();

   whole_window_box = gtk_vbox_new(FALSE, 0);
   gnome_app_set_contents(GNOME_APP(window), whole_window_box);
   gtk_widget_show(whole_window_box);

   table = gtk_table_new(4, 4, TRUE);
   gtk_box_pack_start(GTK_BOX(whole_window_box), table, TRUE, TRUE, 0); 

   tree_window = gtk_scrolled_window_new(0, 0);
   gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(tree_window), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
   gtk_table_attach(GTK_TABLE(table), tree_window, 0, 1, 0, 3, GTK_FILL, GTK_FILL, 0, 0);
   gtk_widget_show(tree_window);
   tree_widget = gtk_tree_new();
   gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(tree_window), tree_widget);
   gtk_tree_set_selection_mode(GTK_TREE(tree_widget), GTK_SELECTION_SINGLE);
   gtk_widget_show(tree_widget);
   
   image_box = gtk_vbox_new(TRUE, 0);
   gtk_table_attach(GTK_TABLE(table), image_box, 1, 4, 0, 2, GTK_FILL, GTK_FILL, 0, 0);
   gtk_widget_show(image_box);

   pixmapwid = gnome_pixmap_new_from_file(aboutimage_filename);
   gtk_box_pack_start(GTK_BOX(image_box), pixmapwid, FALSE, FALSE, 5);
   gtk_widget_show(pixmapwid);

   main_box = gtk_hbox_new(FALSE, 0);
   gtk_table_attach(GTK_TABLE(table), main_box, 1, 4, 2, 3, GTK_FILL, GTK_FILL, 0, 0);
   gtk_widget_show(main_box);

   cur_file.text = gtk_text_new(0, 0);
   gtk_widget_set_usize(GTK_WIDGET(cur_file.text), 570, 100);
   gtk_box_pack_start(GTK_BOX(main_box), cur_file.text, TRUE, TRUE, 0);
   cur_file.scroller = gtk_vscrollbar_new(GTK_TEXT(cur_file.text)->vadj);
   gtk_box_pack_start(GTK_BOX(main_box), cur_file.scroller, FALSE, FALSE, 0);
   gtk_text_set_editable(GTK_TEXT(cur_file.text), FALSE);
   gtk_widget_add_events(cur_file.text, GDK_BUTTON1_MOTION_MASK);
//   gtk_signal_connect(GTK_OBJECT(cur_file.text), "button_press_event", GTK_SIGNAL_FUNC(right_click_handler), NULL);
   gtk_widget_show(cur_file.text);
   gtk_widget_show(cur_file.scroller);

   props_box = gtk_hbox_new(FALSE, 0);
   gtk_table_attach(GTK_TABLE(table), props_box, 0, 4, 3, 4, GTK_FILL, GTK_FILL, 0, 0);

   props_image_entry = gtk_entry_new();
   gtk_box_pack_end(GTK_BOX(props_box), props_image_entry, FALSE, FALSE, 10);
   gtk_entry_set_editable(GTK_ENTRY(props_image_entry), FALSE);   
   gtk_widget_show(props_image_entry);   
   props_image_label = gtk_label_new("Image Path:");
   gtk_box_pack_end(GTK_BOX(props_box), props_image_label, FALSE, FALSE, 10);
   gtk_widget_show(props_image_label);

   props_qty_entry = gtk_entry_new();
   gtk_box_pack_end(GTK_BOX(props_box), props_qty_entry, FALSE, FALSE, 10);
   gtk_entry_set_editable(GTK_ENTRY(props_qty_entry), FALSE);   
   gtk_widget_show(props_qty_entry);   
   props_qty_label = gtk_label_new("Quantity:");
   gtk_box_pack_end(GTK_BOX(props_box), props_qty_label, FALSE, FALSE, 10);
   gtk_widget_show(props_qty_label);

   props_price_entry = gtk_entry_new();
   gtk_box_pack_end(GTK_BOX(props_box), props_price_entry, FALSE, FALSE, 10);
   gtk_entry_set_editable(GTK_ENTRY(props_price_entry), FALSE);   
   gtk_widget_show(props_price_entry);   
   props_price_label = gtk_label_new("Price:");
   gtk_box_pack_end(GTK_BOX(props_box), props_price_label, FALSE, FALSE, 10);
   gtk_widget_show(props_price_label);
   strcpy(cur_file.filename, "Untitled");
   get_prefs();
   flush_file(tempfile1);
   cur_selected_item = NULL;
   cur_selected_tree = NULL;
   adjust_sensitivity();   
   gtk_widget_show(table);
   gtk_widget_show(window);
   gtk_main();
}

gint right_click_handler(GtkWidget *widget, GdkEventButton *event, gpointer *data)
{
   if(cur_selected_item != NULL)
   {
      if(event->type == GDK_BUTTON_PRESS)
      {
         GdkEventButton *bevent = (GdkEventButton *) event; 
         gtk_menu_popup(GTK_MENU(edit_menu), NULL, NULL, NULL, NULL, bevent->button, bevent->time);
         return TRUE;
      }
   }
   return FALSE;
}

void show_selected_item(GtkWidget *root_tree, GtkWidget *selected_item, gpointer *data)
{
   cur_selected_item = selected_item;
   cur_selected_tree = GTK_TREE_ITEM(selected_item)->subtree;

   adjust_sensitivity();

   gtk_tree_item_expand(GTK_TREE_ITEM(cur_selected_item));   
   gtk_editable_delete_text(GTK_EDITABLE(cur_file.text), 0, gtk_text_get_length(GTK_TEXT(cur_file.text)));
   gtk_editable_delete_text(GTK_EDITABLE(props_price_entry), 0, -1);
   gtk_editable_delete_text(GTK_EDITABLE(props_qty_entry), 0, -1);

   char buffer[257] = "";
   char input[257];
   char price[50];
   char *price_ptr = price;
   char quantity[50];
   char *quantity_ptr = quantity;
   char *char_ptr;
   gchar *tree_text;
   GtkLabel *label;

   ifstream Input;
   Input.open(tempfile1);

   label = GTK_LABEL(GTK_BIN(selected_item)->child);
   gtk_label_get(label, &tree_text);
   strcat(buffer, "name = [");
   strcat(buffer, tree_text);
   strcat(buffer, "]");

   while(Input.getline(input, 256) != NULL)
   {
      if((strstr(input, buffer)) == NULL)
         continue;

      for(int iterations = 0; iterations < ITEMS; iterations++)
      {
         if((char_ptr = strstr(input, items[iterations])) != NULL)
         {
            char_ptr += strlen(items[iterations]) - 1;
            if(*char_ptr == '[')
            {
               char_ptr++;
               copy_chars(char_ptr, item_values[iterations], 255);
            }
         }
      }

      gtk_entry_set_text(GTK_ENTRY(props_price_entry), item_values[PRICE]);
      gtk_entry_set_text(GTK_ENTRY(props_qty_entry), item_values[QUANTITY]);
      gtk_entry_set_text(GTK_ENTRY(props_image_entry), item_values[IMAGE]);

      while((Input.getline(input, 256)) != NULL)
      {
         if((strstr(input, "Tree")) != NULL)
            break;
         strcat(input, "\n");        
         gtk_text_insert(GTK_TEXT(cur_file.text), 0, &black, 0, input, -1);
      }
      break;
   }
   Input.close();
   
   if((cur_selected_item != NULL) && (cur_selected_tree == NULL) && (cur_prefs[SHOW_IMAGES] == TRUE))
   {
      kill_widget(pixmapwid, pixmapwid);
      pixmapwid = gnome_pixmap_new_from_file(item_values[IMAGE]);
      if(pixmapwid == NULL)   
         pixmapwid = gnome_pixmap_new_from_file(noimage_filename);
      gtk_box_pack_start(GTK_BOX(image_box), pixmapwid, FALSE, FALSE, 5);
      gtk_widget_show(pixmapwid);
   }
}

    
void unshow_selected_item(GtkWidget *root_tree, GtkWidget *selected_item, gpointer *data)
{
   gtk_editable_delete_text(GTK_EDITABLE(cur_file.text), 0, -1);
   gtk_editable_delete_text(GTK_EDITABLE(props_price_entry), 0, -1);
   gtk_editable_delete_text(GTK_EDITABLE(props_qty_entry), 0, -1);
   cur_selected_item = NULL;
   cur_selected_tree = GTK_TREE_ITEM(selected_item)->subtree;
   kill_widget(pixmapwid, pixmapwid);
   pixmapwid = gnome_pixmap_new_from_file(noimage_filename);
   gtk_box_pack_start(GTK_BOX(image_box), pixmapwid, FALSE, FALSE, 5);
   gtk_widget_show(pixmapwid);
   adjust_sensitivity();
}

void adjust_sensitivity()
{
   if(cur_prefs[ALLOW_EDIT] == TRUE) // editing
   {
      if((cur_selected_item != NULL)) // editing + item
      {
         gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_change), 1);
         gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_newcat), 1);
         if(cur_selected_tree != NULL) // editing + item + subtree
         {
            gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_newsubcat), 1);
            gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_newitem), 1);
            gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_delete), 0);
            gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_item2cat), 0);
            gtk_widget_hide(props_box);
            if(GTK_TREE(GTK_TREE_ITEM(cur_selected_item)->subtree)->children == NULL) // subtree but no items
            {
               gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_cat2item), 1);
            }
            else
            {
               gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_cat2item), 0);             
            }
         }
         else  // just an item
         {
            gtk_widget_show(props_box);
            gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_newsubcat), 0);
            gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_newitem), 0);
            gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_cat2item), 0);
            gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_item2cat), 1);
            if(cur_prefs[ALLOW_DELETE] == TRUE)
               gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_delete), 1);
            else
               gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_delete), 0);            
         }
      }
      else
      {
         gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_change), 0);
         gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_newcat), 1);
         gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_newsubcat), 0);
         gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_newitem), 0);
         gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_cat2item), 0);
         gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_item2cat), 0);
         gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_delete), 0);
      }
   }      
   else
   {
      if((cur_prefs[ALLOW_DELETE] == TRUE) && (cur_selected_item != NULL) && (cur_selected_tree == NULL)) // item w/o tree and delete on
         gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_delete), 1);
      else
         gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_delete), 0);
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_change), 0);
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_newcat), 0);
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_newsubcat), 0);
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_newitem), 0);
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_cat2item), 0);
      gtk_widget_set_sensitive(GTK_WIDGET(edit_menu_item2cat), 0);
   }
   if((cur_selected_item != NULL) && (cur_selected_tree == NULL))
      gtk_widget_show(props_box);
   else
      gtk_widget_hide(props_box);
}


void copy_chars(char *source, char *dest, int max_chars)
{
   char cur_char;
   for(int iterations = 0; iterations < max_chars; iterations++)
   {
      cur_char = *source;
      *dest = cur_char;
      if(cur_char == ']' || cur_char == '\0')
      {
         *dest = '\0';
         break;
      }
      source++;
      dest++;
   }
}


void flush_file(gchar *name)
{
   ofstream Output;
   Output.open(name);
   Output.close();
}


void directory_stuff()
{
   char buffer[256] = "";
   strcat(buffer, gCat_dir);
   strcat(buffer, "/gCatalog.conf");
   ifstream Input;
   Input.open(buffer);
   if(!Input)
   {
      cout << "Creating " << buffer << " ..." << endl;
      char dirbuffer[256] = "mkdir ";
      strcat(dirbuffer, gCat_dir);
      system(dirbuffer);
      save_prefs(FALSE);
   }
   Input.close();
}


void kill_widget(GtkWidget *widget, GtkWidget *target)
{
   gtk_widget_destroy(GTK_WIDGET(target));
}


gint delete_event(GtkWidget *widget, GdkEvent *event, gpointer data)
{
   return(TRUE);
}


void destroy(GtkWidget *widget, gpointer data)
{
   gtk_main_quit();
}
