
void change_settings(GtkWidget *widget, gpointer *data)
{
   GtkWidget *help_text;
   GtkWidget *help_scroller;
   GtkWidget *license_text;
   GtkWidget *license_scroller;
   GtkWidget *label;
   GtkWidget *notebook_box;
   GtkWidget *main_book;
   GtkWidget *aboutpixmap;

   for(int iterations = 0; iterations < PREFS; iterations++)
   {
      backup_prefs[iterations] = cur_prefs[iterations];
   }
   
   change_dialog_window = gtk_window_new(GTK_WINDOW_DIALOG);
   gtk_container_set_border_width(GTK_CONTAINER(change_dialog_window), 10);   
   main_dialog_box = gtk_vbox_new(FALSE, 0);
   gtk_container_add(GTK_CONTAINER(change_dialog_window), main_dialog_box);
   gtk_widget_show(main_dialog_box);

   notebook_box = gtk_hbox_new(TRUE, 5);
   gtk_box_pack_start (GTK_BOX(main_dialog_box), notebook_box, TRUE, TRUE, 5);
   gtk_widget_show(notebook_box);
   main_book = gtk_notebook_new ();
   gtk_notebook_set_tab_pos(GTK_NOTEBOOK(main_book), GTK_POS_TOP);
   gtk_box_pack_start (GTK_BOX(notebook_box), main_book, TRUE, TRUE, 5);
   gtk_widget_show(main_book);
   
   GtkWidget *settings_box = gtk_vbox_new(FALSE, 5);
   gtk_container_set_border_width(GTK_CONTAINER(settings_box), 10);
   gtk_widget_show(settings_box);
   GtkWidget *settings_label = gtk_label_new ("Settings");
   gtk_widget_show(settings_label);
   gtk_notebook_append_page(GTK_NOTEBOOK(main_book), settings_box, settings_label);
   allow_delete = make_button("Allow deletion?", &backup_prefs[ALLOW_DELETE], settings_box);
   allow_edit = make_button("Allow editing?", &backup_prefs[ALLOW_EDIT], settings_box);
   allow_images = make_button("Show images?", &backup_prefs[SHOW_IMAGES], settings_box);
   buttons_box = gtk_hbox_new(TRUE, 0);
   gtk_box_pack_end(GTK_BOX(settings_box), buttons_box, FALSE, FALSE, 5);
   gtk_widget_show(buttons_box);
   save_button = gtk_button_new_with_label(" Save Settings ");
   gtk_box_pack_start(GTK_BOX(buttons_box), save_button, FALSE, TRUE, 10);
   gtk_signal_connect(GTK_OBJECT(save_button), "clicked", GTK_SIGNAL_FUNC(save_settings), 0);
   gtk_widget_show(save_button);
   defaults_button = gtk_button_new_with_label("Set Defaults");
   gtk_box_pack_start(GTK_BOX(buttons_box), defaults_button, FALSE, TRUE, 10);   
   gtk_signal_connect(GTK_OBJECT(defaults_button), "clicked", GTK_SIGNAL_FUNC(get_defaults), 0);
   gtk_widget_show(defaults_button);
   undo_button = gtk_button_new_with_label("Undo Changes");
   gtk_box_pack_start(GTK_BOX(buttons_box), undo_button, FALSE, TRUE, 10);   
   gtk_signal_connect(GTK_OBJECT(undo_button), "clicked", GTK_SIGNAL_FUNC(get_backups), 0);
   gtk_widget_show(undo_button);

   GtkWidget *author_box = gtk_vbox_new(FALSE, 5);
   gtk_container_set_border_width(GTK_CONTAINER(author_box), 10);
   gtk_widget_show(author_box);
   GtkWidget *author_label = gtk_label_new ("Author");
   gtk_widget_show(author_label);
   gtk_notebook_append_page(GTK_NOTEBOOK(main_book), author_box, author_label);
   label = gtk_label_new("Copywrite 1999 under the GPL");
   gtk_box_pack_start(GTK_BOX(author_box), label, FALSE, FALSE, 3);
   gtk_widget_show(label);
   label = gtk_label_new("Chris Phelps a.k.a. Chicane");
   gtk_box_pack_start(GTK_BOX(author_box), label, FALSE, FALSE, 3);
   gtk_widget_show(label);
   label = gtk_label_new("E-mail: chicane@reninet.com");
   gtk_box_pack_start(GTK_BOX(author_box), label, FALSE, FALSE, 3);
   gtk_widget_show(label);

   GtkWidget *help_box = gtk_hbox_new(FALSE, 5);
   gtk_container_set_border_width(GTK_CONTAINER(help_box), 10);
   gtk_widget_show(help_box);
   GtkWidget *help_label = gtk_label_new ("Help");
   gtk_widget_show(help_label);
   gtk_notebook_append_page(GTK_NOTEBOOK(main_book), help_box, help_label);
   help_text = gtk_text_new(0, 0);
   gtk_box_pack_start(GTK_BOX(help_box), help_text, TRUE, TRUE, 0);
   help_scroller = gtk_vscrollbar_new(GTK_TEXT(help_text)->vadj);
   gtk_box_pack_start(GTK_BOX(help_box), help_scroller, FALSE, FALSE, 0);
   gtk_text_set_editable(GTK_TEXT(help_text), FALSE);
   gtk_widget_show(help_text);
   gtk_widget_show(help_scroller);
   write_file_to_gtktext("/usr/local/doc/gCatalog/README", help_text, &blue);
   
   GtkWidget *license_box = gtk_hbox_new(FALSE, 5);
   gtk_container_set_border_width(GTK_CONTAINER(license_box), 10);
   gtk_widget_show(license_box);
   GtkWidget *license_label = gtk_label_new ("License (GPL)");
   gtk_widget_show(license_label);
   gtk_notebook_append_page(GTK_NOTEBOOK(main_book), license_box, license_label);
   license_text = gtk_text_new(0, 0);
   gtk_box_pack_start(GTK_BOX(license_box), license_text, TRUE, TRUE, 0);
   license_scroller = gtk_vscrollbar_new(GTK_TEXT(license_text)->vadj);
   gtk_box_pack_start(GTK_BOX(license_box), license_scroller, FALSE, FALSE, 0);
   gtk_text_set_editable(GTK_TEXT(license_text), FALSE);
   gtk_widget_show(license_text);
   gtk_widget_show(license_scroller);
   write_file_to_gtktext("/usr/local/doc/gCatalog/COPYING", license_text, &red);

   GtkWidget *about_box = gtk_vbox_new(FALSE, 5);
   gtk_container_set_border_width(GTK_CONTAINER(about_box), 10);
   gtk_widget_show(about_box);
   GtkWidget *about_label = gtk_label_new ("About");
   gtk_widget_show(about_label);
   gtk_notebook_append_page(GTK_NOTEBOOK(main_book), about_box, about_label);

   aboutpixmap = gnome_pixmap_new_from_file(aboutimage_filename);
   gtk_box_pack_start(GTK_BOX(about_box), aboutpixmap, FALSE, FALSE, 5);
   gtk_widget_show(aboutpixmap);
   label = gtk_label_new("gCatalog v0.1.1");
   gtk_box_pack_start(GTK_BOX(about_box), label, FALSE, FALSE, 5);
   gtk_widget_show(label);
   label = gtk_label_new("This software is released under the GPL");
   gtk_box_pack_start(GTK_BOX(about_box), label, FALSE, FALSE, 5);
   gtk_widget_show(label);
   label = gtk_label_new("Compiled with gcc using the gtk+ widget set v1.2.6");
   gtk_box_pack_start(GTK_BOX(about_box), label, FALSE, FALSE, 5);
   gtk_widget_show(label);
   label = gtk_label_new("Gnome image used without permission");
   gtk_box_pack_start(GTK_BOX(about_box), label, FALSE, FALSE, 5);
   gtk_widget_show(label);
   
   buttons_box = gtk_hbox_new(TRUE, 0);
   gtk_box_pack_start(GTK_BOX(main_dialog_box), buttons_box, FALSE, FALSE, 5);
   gtk_widget_show(buttons_box);
   cancel_button = gtk_button_new_with_label("   Close   ");
   gtk_box_pack_start(GTK_BOX(buttons_box), cancel_button, FALSE, FALSE, 15);   
   gtk_signal_connect(GTK_OBJECT(cancel_button), "clicked", GTK_SIGNAL_FUNC(kill_widget), GTK_OBJECT(change_dialog_window));
   gtk_widget_show(cancel_button);
   gtk_widget_show(change_dialog_window);

   int number = (int)(char)*data - 48;
   gtk_notebook_set_page(GTK_NOTEBOOK(main_book), number);
}


void save_settings(GtkWidget *widget, gpointer *data)
{
   for(int iterations = 0; iterations < PREFS; iterations++)
   {
      cur_prefs[iterations] = backup_prefs[iterations];
   }
   save_prefs(TRUE);
  
   if(cur_selected_item != NULL)
   {
      widget = cur_selected_item;
      gtk_tree_item_deselect(GTK_TREE_ITEM(cur_selected_item));
      cur_selected_item = widget;
      gtk_tree_item_select(GTK_TREE_ITEM(cur_selected_item));
   }

   adjust_sensitivity();

}


void get_defaults(GtkWidget *widget, gpointer *data)
{
   for(int iterations = 0; iterations < PREFS; iterations++)
   {
      backup_prefs[iterations] = default_prefs[iterations];
   }
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(allow_delete), backup_prefs[0]);
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(allow_edit), backup_prefs[1]);   
}


void get_backups(GtkWidget *widget, gpointer *data)
{
   for(int iterations = 0; iterations < PREFS; iterations++)
   {
      backup_prefs[iterations] = cur_prefs[iterations];
   }
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(allow_delete), backup_prefs[0]);
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(allow_edit), backup_prefs[1]);   
}


GtkWidget *make_button(gchar *button_text, gint *value, GtkWidget *which_box)
{
   GtkWidget *button;
   button = gtk_check_button_new_with_label(button_text);
   gtk_toggle_button_set_state(GTK_TOGGLE_BUTTON(button), *value);
   gtk_box_pack_start(GTK_BOX(which_box), button, FALSE, FALSE, 0);
   gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(toggle_value), value);
   gtk_widget_show(button);
   return button;
}

void toggle_value(GtkWidget *w, gint *value)
{
   if (*value == 1)
      *value = 0;
   else
      *value = 1;
}

void write_file_to_gtktext(gchar *filename, GtkWidget *text, GdkColor *color)
{
   ifstream Input;
   char input[257] = "";
   Input.open(filename);
   if(!Input)
   {
      cout << "The file " << filename << " does not exist." << endl;
      return;
   }
   gtk_text_freeze(GTK_TEXT(text));
   while((Input.getline(input, 256)) != NULL)
   {
      strcat(input, "\n");
      gtk_text_insert(GTK_TEXT(text), 0, color, 0, input, -1);
   }
   gtk_text_thaw(GTK_TEXT(text));
   return;
}